#
# Conditional build:
%bcond_with	tests	# unit tests
%bcond_with	python2 # CPython 2.x module
%bcond_without	python3 # CPython 3.x module

%if %{with python3}
%undefine with_python2
%endif

# NOTES:
# - 'module' should match the Python import path (first component?)
# - 'egg_name' should equal to Python egg name
# - 'pypi_name' must match the Python Package Index name
%define		module		dkimpy-milter
Summary:	DKIM signing and verification milter
Name:		python-%{module}
Version:	1.2.3
Release:	1%{?tld}
License:	BSD-like
Group:		Libraries/Python
Source0:	https://files.pythonhosted.org/packages/source/d/dkimpy-milter/%{module}-%{version}.tar.gz
# Source0-md5:	80af06b5fb348b7d1a762a9418ab9e00
Source1:	dkimpy-milter.init
Patch0:		paths.patch
Patch1:		config.patch
URL:		https://launchpad.net/dkimpy-milter
%if %{with python2}
BuildRequires:	python-modules >= 1:2.5
BuildRequires:	python-setuptools
%if %{with tests}
BuildRequires:	python-PyNaCl
BuildRequires:	python-aiodns
BuildRequires:	python-authres
BuildRequires:	python-dns >= 1.16
BuildRequires:	python-pymilter
%endif
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.2
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-PyNaCl
BuildRequires:	python3-aiodns
BuildRequires:	python3-authres
BuildRequires:	python3-dns >= 1.16
BuildRequires:	python3-pymilter
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
Requires:	python-modules >= 1:2.5
Requires:	python-setuptools
Conflicts:	python3-dkimpy-milter
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
DKIM signing and verification milter.

%package -n python3-%{module}
Summary:	DKIM signing and verification milter
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.2
Requires:	python3-setuptools
Conflicts:	python-dkimpy-milter

%description -n python3-%{module}
DKIM signing and verification milter

%prep
%setup -q -n %{module}-%{version}
%patch0 -p1
%patch1 -p1

%build
%if %{with python2}
%py_build %{?with_tests:test}
%endif

%if %{with python3}
%py3_build %{?with_tests:test}
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{/etc/{dkimpy-milter/keys,rc.d/init.d},/usr/sbin}
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/dkimpy-milter
touch $RPM_BUILD_ROOT/etc/dkimpy-milter/{KeyTable,KeyTableEd25519,SigningTable}

%if %{with python2}
%py_install

%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

%{__mv} $RPM_BUILD_ROOT/usr/etc/dkimpy-milter/dkimpy-milter.conf $RPM_BUILD_ROOT/etc/dkimpy-milter/dkimpy-milter.conf
%{__mv} $RPM_BUILD_ROOT/usr/bin/dkimpy-milter $RPM_BUILD_ROOT/usr/sbin/dkimpy-milter

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 346 dkimpy-milter
%useradd -u 346 -d /usr/share/empty -g dkimpy-milter -c "dkimpy-milter daemon user" dkimpy-milter

%post
/sbin/chkconfig --add dkimpy-milter
%service dkimpy-milter restart

%postun
if [ "$1" = "0" ]; then
	%userremove dkimpy-milter
	%groupremove dkimpy-milter
fi

%preun
if [ "$1" = "0" ]; then
        %service dkimpy-milter stop
        /sbin/chkconfig --del dkimpy-milter
fi

%pre -n python3-%{module}
%groupadd -g 346 dkimpy-milter
%useradd -u 346 -d /usr/share/empty -g dkimpy-milter -c "dkimpy-milter daemon user" dkimpy-milter

%post -n python3-%{module}
/sbin/chkconfig --add dkimpy-milter
%service dkimpy-milter restart

%postun -n python3-%{module}
if [ "$1" = "0" ]; then
	%userremove dkimpy-milter
	%groupremove dkimpy-milter
fi

%preun -n python3-%{module}
if [ "$1" = "0" ]; then
        %service dkimpy-milter stop
        /sbin/chkconfig --del dkimpy-milter
fi

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc README.md CHANGES
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/dkimpy-milter.conf
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/KeyTable
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/KeyTableEd25519
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/SigningTable
%dir %attr(750,dkimpy-milter,dkimpy-milter) /etc/dkimpy-milter
%dir %attr(750,dkimpy-milter,dkimpy-milter) /etc/dkimpy-milter/keys
%attr(754,root,root) /etc/rc.d/init.d/dkimpy-milter
%attr(755,root,root) %{_sbindir}/dkimpy-milter
%{_mandir}/man5/dkimpy-milter.conf.5*
%{_mandir}/man8/dkimpy-milter.8*
%{py_sitescriptdir}/dkimpy_milter
%{py_sitescriptdir}/dkimpy_milter-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-%{module}
%defattr(644,root,root,755)
%doc README.md CHANGES
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/dkimpy-milter.conf
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/KeyTable
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/KeyTableEd25519
%attr(640,dkimpy-milter,dkimpy-milter) %config(noreplace) %verify(not md5 mtime size) /etc/dkimpy-milter/SigningTable
%dir %attr(750,dkimpy-milter,dkimpy-milter) /etc/dkimpy-milter
%dir %attr(750,dkimpy-milter,dkimpy-milter) /etc/dkimpy-milter/keys
%attr(754,root,root) /etc/rc.d/init.d/dkimpy-milter
%attr(755,root,root) %{_sbindir}/dkimpy-milter
%{_mandir}/man5/dkimpy-milter.conf.5*
%{_mandir}/man8/dkimpy-milter.8*
%{py3_sitescriptdir}/dkimpy_milter
%{py3_sitescriptdir}/dkimpy_milter-%{version}-py*.egg-info
%endif
%changelog
* Wed Apr 24 2024 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/python-dkimpy-milter.git;a=log;h=master

* Wed Apr 24 2024 Marcin Krol <hawk@tld-linux.org> dea8e11
- updated to 1.2.3

* Mon May 30 2022 Marcin Krol <hawk@tld-linux.org> a8bb744
- fixed typo in filename

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 192ab88
- fix /etc/dkimpy-milter dirs

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 2aa5761
- seems to work

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 504d7d8
- use .socket for unix socket like in other milters

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> fadadac
- do not enable tables by default, empty tables will prevent daemon from
  starting

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> e228237
- config files/dirs owned by dkimpy-milter user/group
- provide empty key and signing table files

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 806affb
- add/remove daemon user/group

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 87c5612
- more complete config

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 954605e
- alter only paths with this patch, don't touch config

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 75c9d17
- directory for keys

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 9f1adb0
- take care of stale pid files, daemon requires fork

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 24e59a7
- put binary in /sbin like other milters

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> c300b88
- prefer inet socket by default

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 4a60539
- dkimpy dir under postfix spool

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 454bbbd
- package config file, still NFY

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 3e71035
- run as nobody by default

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 7afd9b0
- fix paths, init script, allow only python 2 or 3 not both, still NFY

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> c36f7f1
- R python setuptools

* Sun May 29 2022 Marcin Krol <hawk@tld-linux.org> 0302b0f
- summary and description

